## pmdk 1.11.1

=== src/benchmarks/Makefile ===
# SPDX-License-Identifier: BSD-3-Clause
# Copyright 2014-2020, Intel Corporation

#
# src/benchmarks/Makefile -- build all benchmarks
#
TOP := $(dir $(lastword $(MAKEFILE_LIST)))../..

include $(TOP)/src/common.inc

vpath %.c $(TOP)/src/examples/libpmemobj/tree_map
vpath %.c $(TOP)/src/examples/libpmemobj/map
vpath %.c $(TOP)/src/examples/libpmemobj/hashmap

vpath %.c $(TOP)/src/libpmemobj
vpath %.c $(TOP)/src/common
vpath %.c $(TOP)/src/librpmem
vpath %.c $(TOP)/src/rpmem_common
vpath %.c $(TOP)/src/libpmempool

BENCHMARK = pmembench

GLIB:= $(call check_package, glib-2.0)
ifeq ($(GLIB),y)
TARGET = $(BENCHMARK)
else
$(info NOTE: Skipping pmembench because glib-2.0 is missing \
-- see src/benchmarks/README for details.)
endif

all: $(TARGET)

SRC=pmembench.cpp\
    benchmark_time.cpp\
    benchmark_worker.cpp\
    clo.cpp\
    clo_vec.cpp\
    config_reader.cpp\
    scenario.cpp\
    log.cpp\
    blk.cpp\
    pmem_memset.cpp\
    pmem_memcpy.cpp\
    pmem_flush.cpp\
    pmemobj_gen.cpp\
    pmemobj_persist.cpp\
    obj_pmalloc.cpp\
    obj_locks.cpp\
    obj_lanes.cpp\
    map_bench.cpp\
    pmemobj_tx.cpp\
    pmemobj_atomic_lists.cpp\
    poolset_util.cpp\
    benchmark_empty.cpp\
    pmemobj_tx_add_range.cpp

# Configuration file without the .cfg extension
CONFIGS=pmembench_log\
	pmembench_blk\
	pmembench_memset\
	pmembench_memcpy\
	pmembench_flush\
	pmembench_obj_pmalloc\
	pmembench_obj_persist\
	pmembench_obj_gen\
	pmembench_obj_locks\
	pmembench_obj_lanes\
	pmembench_map\
	pmembench_tx\
	pmembench_atomic_lists

OBJS=$(SRC:.cpp=.o)
ifneq ($(filter 1 2, $(CSTYLEON)),)
TMP_HEADERS := $(addsuffix tmp, $(HEADERS))
endif
LDFLAGS = -L$(LIBS_PATH) $(OS_LIBS)
LDFLAGS += -L../examples/libpmemobj/map
LDFLAGS += $(EXTRA_LDFLAGS)
ifeq ($(DEBUG),)
LIBS += ../nondebug/libpmemcore.a
LIBS += ../nondebug/libpmemcommon.a
else
LIBS += ../debug/libpmemcore.a
LIBS += ../debug/libpmemcommon.a
endif
CFLAGS += $(LIBNDCTL_CFLAGS)
LIBS += -lpmemobj -lpmemlog -lpmemblk -lpmempool -lpmem -pthread -lm \
	$(LIBDL) $(LIBUUID) $(LIBNDCTL_LIBS)
ifeq ($(LIBRT_NEEDED), y)
LIBS += -lrt
endif

CXXFLAGS = -Wall
CXXFLAGS += -Werror
CXXFLAGS += -std=c++11
CXXFLAGS += -Wno-invalid-offsetof
CXXFLAGS += -Wpointer-arith
CXXFLAGS += -Wunused-macros
CXXFLAGS += -pthread
CXXFLAGS += -I../include
CXXFLAGS += -I../libpmemobj
CXXFLAGS += -I../common
CXXFLAGS += -I../core
CXXFLAGS += -I../examples/libpmemobj/map
CXXFLAGS += -I../rpmem_common
CXXFLAGS += -I../librpmem
CXXFLAGS += $(OS_INCS)
CXXFLAGS += -DSRCVERSION='"$(SRCVERSION)"'

ifeq ($(OS_DIMM),ndctl)
CXXFLAGS += -DSDS_ENABLED
endif

ifeq ($(COVERAGE),1)
CXXFLAGS += $(GCOV_CFLAGS)
LDFLAGS += $(GCOV_LDFLAGS)
LIBS += $(GCOV_LIBS)
endif

ifneq ($(SANITIZE),)
CXXFLAGS += -fsanitize=$(SANITIZE)
LDFLAGS += -fsanitize=$(SANITIZE)
endif

ifeq ($(BUILD_RPMEM),y)
SRC += rpmem.cpp
LIBS += -lrpmem $(LIBFABRIC_LIBS)
CONFIGS += pmembench_rpmem
CXXFLAGS += -DRPMEM_AVAILABLE
else
$(info NOTE: Skipping librpmem benchmark because $(BUILD_RPMEM_INFO))
endif

ifeq ($(GLIB),y)
CXXFLAGS += $(shell $(PKG_CONFIG) --cflags glib-2.0)
LIBS += $(shell $(PKG_CONFIG) --libs glib-2.0)
endif

LIBMAP_DIR=../examples/libpmemobj/map
LIBMAP=$(LIBMAP_DIR)/libmap.a

OBJS += pmemobj.o

ifeq ($(DEBUG),)
CXXFLAGS += -O3
LIBS_PATH=../nondebug
else
CXXFLAGS += -ggdb
LIBS_PATH=../debug
endif

GLIB_TEST_PROG="\#include <glib.h>\nint main(){return 0;}"
GLIB_SILENCE := $(shell printf $(GLIB_TEST_PROG) |\
	$(CXX) $(CXXFLAGS) -x c -o /dev/null - 2>/dev/null && echo n || echo y)

ifeq ($(GLIB_SILENCE), y)
CXXFLAGS += -Wno-unknown-attributes
endif

CXXFLAGS += $(EXTRA_CXXFLAGS)

objdir=.

%.o: %.cpp Makefile
	$(call check-cstyle, $<)
	@mkdir -p .deps
	$(CXX) -MD -c -o $@ $(CXXFLAGS) $(call coverage-path, $<)
	$(call check-os, $@, $<)
	$(create-deps)

%.htmp: %.h
	$(call check-cstyle, $<, $@)

%.hpptmp: %.hpp
	$(call check-cstyle, $<, $@)

$(BENCHMARK): $(TMP_HEADERS) $(OBJS) $(LIBMAP)
	$(CXX) -o $@ $(LDFLAGS) $(OBJS) $(LIBMAP) $(LIBS)

$(LIBMAP):
	$(MAKE) -C $(LIBMAP_DIR) map

clean:
	$(RM) $(OBJS) $(TMP_HEADERS)
	$(RM) *.csv

clobber: clean
	$(RM) $(BENCHMARK)
	$(RM) *.csv
	$(RM) -r .deps

$(CONFIGS):
	LD_LIBRARY_PATH=$(LIBS_PATH) ./$(BENCHMARK) $@.cfg > $@.csv

run: $(BENCHMARK) $(CONFIGS)

sparse:

.PHONY: all clean clobber run $(CONFIGS)

PMEMOBJ_SYMBOLS=pmalloc pfree lane_hold lane_release

pmemobj.o: $(LIBS_PATH)/libpmemobj/libpmemobj_unscoped.o
	$(OBJCOPY) --localize-hidden $(addprefix -G, $(PMEMOBJ_SYMBOLS)) $< $@

-include .deps/*.P

=== src/libpmem/Makefile ===
# SPDX-License-Identifier: BSD-3-Clause
# Copyright 2014-2020, Intel Corporation

#
# src/libpmem/Makefile -- Makefile for libpmem
#

include ../common.inc

LIBRARY_NAME = pmem
LIBRARY_SO_VERSION = 1
LIBRARY_VERSION = 0.0
SOURCE =\
	$(CORE)/alloc.c\
	$(CORE)/fs_posix.c\
	$(CORE)/os_posix.c\
	$(CORE)/os_thread_posix.c\
	$(CORE)/out.c\
	$(CORE)/util.c\
	$(CORE)/util_posix.c\
	$(COMMON)/file.c\
	$(COMMON)/file_posix.c\
	$(COMMON)/mmap.c\
	$(COMMON)/mmap_posix.c\
	$(COMMON)/os_deep_linux.c\
	libpmem.c\
	memops_generic.c\
	pmem.c\
	pmem_posix.c\
	$(PMEM2)/pmem2_utils.c\
	$(PMEM2)/config.c\
	$(PMEM2)/persist_posix.c\
	$(PMEM2)/source.c\
	$(PMEM2)/source_posix.c

ifeq ($(OS_KERNEL_NAME),Linux)
SOURCE +=\
	$(PMEM2)/pmem2_utils_linux.c\
	$(PMEM2)/pmem2_utils_$(OS_DIMM).c\
	$(PMEM2)/auto_flush_linux.c\
	$(PMEM2)/deep_flush_linux.c
else
SOURCE +=\
	$(PMEM2)/pmem2_utils_other.c\
	$(PMEM2)/auto_flush_none.c\
	$(PMEM2)/deep_flush_other.c
endif

ifeq ($(OS_DIMM),ndctl)
SOURCE +=\
	region_namespace_ndctl.c\
	numa_ndctl.c
CFLAGS += $(LIBNDCTL_CFLAGS)
LIBS += $(LIBNDCTL_LIBS)
else
SOURCE +=\
	region_namespace_none.c\
	numa_none.c
endif

INCS += -I$(TOP)/src/libpmem2

include ../libpmem2/$(ARCH)/sources.inc

SOURCE += $(LIBPMEM2_ARCH_SOURCE)

include ../Makefile.inc

include $(PMEM2)/$(ARCH)/flags.inc

CFLAGS += -I.
LIBS += -pthread

=== src/libpmemset/Makefile ===

# SPDX-License-Identifier: BSD-3-Clause
# Copyright 2020, Intel Corporation

#
# src/libpmemset/Makefile -- Makefile for libpmemset
#

include ../common.inc

LIBRARY_NAME = pmemset
LIBRARY_SO_VERSION = 1
LIBRARY_VERSION = 0.0
SOURCE =\
	config.c\
	errormsg.c\
	file.c\
	file_posix.c\
	libpmemset.c\
	part.c\
	pmemset.c\
	pmemset_utils.c\
	source.c

include ../core/pmemcore.inc
include ../Makefile.inc

CFLAGS += -I.
LIBS += -pthread -lpmem2

=== src/test/Makefile ===
# SPDX-License-Identifier: BSD-3-Clause
# Copyright 2014-2021, Intel Corporation
#

#
# src/test/Makefile -- build all unit tests
#
# Makefile -- build all unit tests
#

include ../common.inc

TEST_DEPS = \
	unittest\
	tools

BLK_TESTS = \
	blk_include\
	blk_nblock\
	blk_non_zero\
	blk_pool\
	blk_pool_lock\
	blk_recovery\
	blk_rw\
	blk_rw_mt

LOG_TESTS = \
	log_basic\
	log_include\
	log_pool\
	log_pool_lock\
	log_recovery\
	log_walker

OBJ_DEPS = \
	obj_list

# long tests first
OBJ_TESTS = \
	obj_basic_integration\
	obj_many_size_allocs\
	obj_realloc\
	obj_sync\
	\
	obj_action\
	obj_alloc\
	obj_badblock\
	obj_bucket\
	obj_check\
	obj_constructor\
	obj_critnib\
	obj_critnib_mt\
	obj_ctl_alignment\
	obj_ctl_alloc_class\
	obj_ctl_alloc_class_config\
	obj_ctl_arenas\
	obj_ctl_config\
	obj_ctl_debug\
	obj_ctl_heap_size\
	obj_ctl_stats\
	obj_debug\
	obj_defrag\
	obj_defrag_advanced\
	obj_direct\
	obj_direct_volatile\
	obj_extend\
	obj_first_next\
	obj_fragmentation\
	obj_fragmentation2\
	obj_heap\
	obj_heap_interrupt\
	obj_heap_state\
	obj_include\
	obj_lane\
	obj_layout\
	obj_list_insert\
	obj_list_move\
	obj_list_recovery\
	obj_list_remove\
	obj_list_valgrind\
	obj_list_macro\
	obj_locks\
	obj_mem\
	obj_memblock\
	obj_memcheck\
	obj_memcheck_register\
	obj_memops\
	obj_oid_thread\
	obj_out_of_memory\
	obj_persist_count\
	obj_pmalloc_basic\
	obj_pmalloc_mt\
	obj_pmalloc_oom_mt\
	obj_pmalloc_rand_mt\
	obj_pmemcheck\
	obj_pool\
	obj_pool_lock\
	obj_pool_lookup\
	obj_pool_open_mt\
	obj_recovery\
	obj_recreate\
	obj_root\
	obj_reorder_basic\
	obj_strdup\
	obj_sds\
	obj_toid\
	obj_tx_alloc\
	obj_tx_add_range\
	obj_tx_add_range_direct\
	obj_tx_callbacks\
	obj_tx_flow\
	obj_tx_free\
	obj_tx_invalid\
	obj_tx_lock\
	obj_tx_locks\
	obj_tx_locks_abort\
	obj_tx_mt\
	obj_tx_realloc\
	obj_tx_strdup\
	obj_tx_user_data\
	obj_ulog_size\
	obj_zones

OBJ_REMOTE_DEPS = \
	obj_basic_integration\
	obj_heap_interrupt\
	obj_heap_state

OBJ_REMOTE_TESTS = \
	obj_rpmem_basic_integration\
	obj_rpmem_heap_interrupt\
	obj_rpmem_heap_state\
	obj_check_remote

OTHER_TESTS = \
	arch_flags\
	bttdevice\
	checksum\
	compat_incompat_features\
	ctl_prefault\
	ctl_cow\
	getopt\
	magic\
	mmap\
	mmap_fixed\
	out_err\
	out_err_mt\
	pmemobjcli\
	pmemspoil\
	scope\
	set_funcs\
	traces\
	traces_custom_function\
	traces_pmem\
	unicode_api\
	unicode_match_script\
	util_badblock\
	util_ctl\
	util_extent\
	util_file_create\
	util_file_open\
	util_is_absolute\
	util_is_poolset\
	util_is_zeroed\
	util_map_proc\
	util_parse_size\
	util_pool_hdr\
	util_poolset\
	util_poolset_foreach\
	util_poolset_parse\
	util_poolset_size\
	util_ravl\
	util_sds\
	util_uuid_generate\
	util_vec\
	util_vecq

ifeq ($(ARCH), x86_64)
OTHER_TESTS += \
	util_cpuid
endif

PMEM_TESTS = \
	pmem_include\
	pmem_is_pmem\
	pmem_is_pmem_posix\
	pmem_map_file\
	pmem_map_file_trunc\
	pmem_has_auto_flush\
	pmem_deep_persist\
	pmem_memcpy\
	pmem_memmove\
	pmem_memset\
	pmem_movnt\
	pmem_movnt_align\
	pmem_valgr_simple\
	pmem_unmap

PMEM2_TESTS = \
	pmem2_api\
	pmem2_compat\
	pmem2_config\
	pmem2_source\
	pmem2_source_alignment\
	pmem2_source_size\
	pmem2_granularity\
	pmem2_include\
	pmem2_integration\
	pmem2_granularity_detection\
	pmem2_map\
	pmem2_map_from_existing\
	pmem2_map_prot\
	pmem2_persist\
	pmem2_persist_valgrind\
	pmem2_perror\
	pmem2_memcpy\
	pmem2_memmove\
	pmem2_memset\
	pmem2_movnt\
	pmem2_movnt_align\
	pmem2_mem_ext\
	pmem2_deep_flush\
	pmem2_vm_reservation

ifeq ($(OS_DIMM),ndctl)
PMEM2_TESTS += \
	pmem2_badblock_mocks\
	pmem2_source_numa
else
$(info NOTE: Skipping tests because libndctl is disabled (see NDCTL_ENABLE)\
		Skipped tests: pmem2_badblock_mocks pmem2_source_numa)
endif

PMEMPOOL_TESTS = \
	pmempool_check\
	pmempool_create\
	pmempool_dump\
	pmempool_feature\
	pmempool_help\
	pmempool_info\
	pmempool_rm\
	pmempool_sync\
	pmempool_transform

RPMEM_TESTS = \
	rpmem_addr\
	rpmem_addr_ext\
	rpmem_basic\
	rpmem_fip\
	rpmem_obc\
	rpmem_obc_int\
	rpmem_proto\
	rpmemd_config\
	rpmemd_db\
	rpmemd_dbg\
	rpmemd_log\
	rpmemd_obc\
	rpmemd_util

EXAMPLES_TESTS = \
	ex_libpmem\
	ex_libpmem2\
	ex_libpmemblk\
	ex_libpmemlog\
	ex_libpmemobj\
	ex_linkedlist

RPMEM_EXAMPLES_TESTS = \
	ex_librpmem_manpage\
	ex_librpmem_basic\
	ex_librpmem_hello\
	ex_librpmem_fibonacci

LIBPMEMPOOL_DEPS = \
	libpmempool_api

LIBPMEMPOOL_TESTS = \
	libpmempool_include\
	libpmempool_backup\
	libpmempool_bttdev\
	libpmempool_check_version\
	libpmempool_feature\
	libpmempool_map_flog\
	libpmempool_rm

LIBPMEMPOOL_MOD_DEPS = \
	libpmempool_sync

LIBPMEMPOOL_MOD_TESTS = \
	libpmempool_transform

DAXIO_TESTS = \
	daxio

PMREORDER_TESTS = \
	pmreorder_flushes\
	pmreorder_simple\
	pmreorder_stack

PMEMSET_TESTS = \
	pmemset_config\
	pmemset_deep_flush\
	pmemset_event\
	pmemset_file\
	pmemset_include\
	pmemset_memcpy\
	pmemset_memmove\
	pmemset_memset\
	pmemset_new\
	pmemset_part\
	pmemset_perror\
	pmemset_persist\
	pmemset_source

LOCAL_TESTS = \
	$(OBJ_TESTS)\
	$(BLK_TESTS)\
	$(LOG_TESTS)\
	$(OTHER_TESTS)\
	$(PMEM_TESTS)\
	$(PMEM2_TESTS)\
	$(PMEMSET_TESTS)\
	$(PMEMPOOL_TESTS)\
	$(LIBPMEMPOOL_TESTS)\
	$(LIBPMEMPOOL_MOD_TESTS)\
	$(DAXIO_TESTS)\
	$(PMREORDER_TESTS)

REMOTE_TESTS = \
	$(OBJ_REMOTE_TESTS)\
	$(RPMEM_TESTS)\
	libpmempool_rm_remote\
	remote_basic\
	remote_obj_basic\
	pmempool_info_remote\
	pmempool_feature_remote\
	pmempool_rm_remote\
	pmempool_sync_remote\
	pmempool_transform_remote

ifneq ($(BUILD_EXAMPLES),n)
	LOCAL_TESTS += $(EXAMPLES_TESTS)
	REMOTE_TESTS += $(RPMEM_EXAMPLES_TESTS)
endif

TESTS = \
	$(LOCAL_TESTS)\
	$(REMOTE_TESTS)

TESTS_BUILD = \
	$(TEST_DEPS)\
	$(OBJ_DEPS)\
	$(LIBPMEMPOOL_DEPS)\
	$(LIBPMEMPOOL_MOD_DEPS)\
	$(TESTS)

ifneq ($(BLACKLIST_FILE),)
ifeq ("$(wildcard $(BLACKLIST_FILE))","")
$(error Missing blacklist file: $(BLACKLIST_FILE))
endif
	BLACKLIST_TESTS := $(shell cat $(BLACKLIST_FILE))
	TESTS := $(filter-out $(BLACKLIST_TESTS),$(TESTS))
	LOCAL_TESTS := $(filter-out $(BLACKLIST_TESTS),$(LOCAL_TESTS))
	REMOTE_TESTS := $(filter-out $(BLACKLIST_TESTS),$(REMOTE_TESTS))
	TESTS_BUILD := $(filter-out $(BLACKLIST_TESTS),$(TESTS_BUILD))
endif

all     : TARGET = all
clean   : TARGET = clean
clobber : TARGET = clobber
test    : TARGET = test
cstyle  : TARGET = cstyle
format  : TARGET = format
check   : TARGET = check
pcheck  : TARGET = pcheck
sparse  : TARGET = sparse
pycheck : TARGET = pycheck

DIR_SYNC=$(TOP)/src/test/.sync-dir
SYNC_EXT=synced
TESTCONFIG=$(TOP)/src/test/testconfig.sh
FILE_MAX_DAX_DEVICES=$(TOP)/src/test/tools/anonymous_mmap/max_dax_devices

all test format sparse: $(TESTS_BUILD) envconfig.sh envconfig.py

cstyle: $(TESTS_BUILD)
	$(CHECK_SHEBANG) $(foreach dir,$(TESTS_BUILD),$(dir)/TEST? $(dir)/TEST??)

clean clobber: $(TESTS_BUILD)
	$(RM) -r $(DIR_SYNC)
	$(RM) *.$(SYNC_EXT)
	$(RM) $(FILE_MAX_DAX_DEVICES)
	$(RM) envconfig.sh envconfig.py

$(TESTS) $(OBJ_DEPS) $(LIBPMEMPOOL_DEPS) $(LIBPMEMPOOL_MOD_DEPS): $(TEST_DEPS)

$(OBJ_TESTS): $(OBJ_DEPS)
$(OBJ_REMOTE_TESTS): $(OBJ_REMOTE_DEPS)
$(LIBPMEMPOOL_TESTS): $(LIBPMEMPOOL_DEPS)
$(LIBPMEMPOOL_MOD_TESTS): $(LIBPMEMPOOL_MOD_DEPS)

$(TESTS_BUILD):
	$(MAKE) -C $@ $(TARGET)

envconfig.sh:
	@printf "# autogenerated file\nGLOBAL_LIB_PATH=%s\nGLOBAL_PATH=%s\nGLOBAL_PKG_CONFIG_PATH=%s\n" "$(LIBFABRIC_LD_LIBRARY_PATHS):$(LIBNDCTL_LD_LIBRARY_PATHS)" "$(LIBFABRIC_PATH)" "$(PKG_CONFIG_PATH)" > envconfig.sh

PMEM2_AVX512F_ENABLED := $(shell strings $(TOP)/src/debug/libpmem2/libpmem2_all.o 2>&1 | \
	grep -q "avx512f supported, but disabled at build time" && echo "0" || echo "1")

envconfig.py:
	@printf "# autogenerated file\nconfig = {\n  'GLOBAL_LIB_PATH': '%s',\n  'PMEM2_AVX512F_ENABLED': '%s',\n  'GLOBAL_PATH': '%s',\n  'GLOBAL_PKG_CONFIG_PATH': '%s'\n}\n" \
		"$(LIBFABRIC_LD_LIBRARY_PATHS):$(LIBNDCTL_LD_LIBRARY_PATHS)" "$(PMEM2_AVX512F_ENABLED)" "$(LIBFABRIC_PATH)" "$(PKG_CONFIG_PATH)" > envconfig.py

require-rpmem:
ifneq ($(BUILD_RPMEM),y)
	$(error ERROR: cannot run remote tests because $(BUILD_RPMEM_INFO))
endif

memcheck-summary:
	grep ERROR */memcheck*.log

memcheck-summary-errors:
	grep ERROR */memcheck*.log | grep -v " 0 errors" || true

memcheck-summary-leaks:
	grep "in use at exit" */memcheck*.log | grep -v " 0 bytes in 0 blocks" || true

check:
	@[ -z "$(BLACKLIST_TESTS)" ] || echo "Blacklisted tests: $(BLACKLIST_TESTS)"
	@./RUNTESTS $(RUNTEST_OPTIONS) $(LOCAL_TESTS)
	$(MAKE) check-remote-quiet-conditional
	@echo "No failures."

pycheck: TARGET = pycheck
pycheck: $(TESTS)
	@echo "No failures."

check-remote-quiet-conditional:
ifeq ($(BUILD_RPMEM),y)
	$(MAKE) check-remote-quiet
else
	$(info NOTE: Skipping remote tests because $(BUILD_RPMEM_INFO))
endif

check-remote-quiet: sync-remotes
	@MAKEFLAGS="$(MAKEFLAGS)" ./RUNTESTS $(RUNTEST_OPTIONS) $(REMOTE_TESTS)

sync-remotes: require-rpmem test

check-remote: check-remote-quiet
	@echo "No failures."

# XXX remote tests do not work in parallel mode
pcheck: pcheck-local-quiet check-remote-quiet-conditional
	@echo "No failures."

pcheck-blk: TARGET = pcheck
pcheck-blk: $(BLK_TESTS)
	@echo "No failures."

pcheck-log: TARGET = pcheck
pcheck-log: $(LOG_TESTS)
	@echo "No failures."

pcheck-obj: TARGET = pcheck
pcheck-obj: $(OBJ_TESTS)
	@echo "No failures."

pcheck-other: TARGET = pcheck
pcheck-other: $(OTHER_TESTS)
	@echo "No failures."

pcheck-pmem: TARGET = pcheck
pcheck-pmem: $(PMEM_TESTS)
	@echo "No failures."

pcheck-pmem2: TARGET = pcheck
pcheck-pmem2: $(PMEM2_TESTS)
	@echo "No failures."

pcheck-pmemset: TARGET = pcheck
pcheck-pmemset: $(PMEMSET_TESTS)
	@echo "No failures."

pcheck-rpmem: TARGET = pcheck
pcheck-rpmem: $(RPMEM_TESTS)
	@echo "No failures."

pcheck-pmempool: TARGET = pcheck
pcheck-pmempool: $(PMEMPOOL_TESTS)
	@echo "No failures."

pcheck-libpmempool: TARGET = pcheck
pcheck-libpmempool: $(LIBPMEMPOOL_TESTS)
	@echo "No failures."

pcheck-local-quiet: TARGET = pcheck
pcheck-local-quiet: $(LOCAL_TESTS)

pcheck-local: pcheck-local-quiet
	@echo "No failures."

pcheck-remote: TARGET = pcheck
pcheck-remote: $(REMOTE_TESTS)
	@echo "No failures."

$(TESTCONFIG):

SUPP_SYNC_FILES=$(shell echo *.supp | sed s/supp/$(SYNC_EXT)/g)

%.$(SYNC_EXT): %.supp $(TESTCONFIG)
	cp $(shell echo $^ | cut -d" " -f1) $(DIR_SYNC)
	@touch $@

# sync remote nodes
sync-remotes:
ifeq ($(FORCE_SYNC_REMOTES),y)
	@touch $(TESTCONFIG)
endif
ifneq ($(SKIP_SYNC_REMOTES),y)
	@rm -rf $(DIR_SYNC) && mkdir -p $(DIR_SYNC)
	$(MAKE) $(SUPP_SYNC_FILES)
	$(MAKE) -C tools $@
	$(MAKE) -C ../tools $@
	$(MAKE) -C sync-remotes $@
	@for test in $(REMOTE_TESTS); do \
		echo "$(MAKE) -C $$test sync-test" ; \
		$(MAKE) -C $$test sync-test || exit 1 ; \
	done
	@rm -rf $(DIR_SYNC)
endif

.PHONY: all check clean clobber cstyle pcheck pcheck-blk pcheck-log pcheck-obj\
	 pcheck-other pcheck-pmem pcheck-pmempool\
	 test unittest tools check-remote format pcheck-libpmempool pycheck\
	 pcheck-rpmem pcheck-local pcheck-remote sync-remotes $(TESTS_BUILD)\
	 require-rpmem check-remote-quiet check-remote-quiet-conditional

=== src/test/blk_nblock/Makefile ===
# SPDX-License-Identifier: BSD-3-Clause
# Copyright 2014-2019, Intel Corporation

#
# src/test/blk_nblock/Makefile -- build blk_nblock unit test
#
TARGET = blk_nblock
OBJS = blk_nblock.o

LIBPMEMBLK=y

include ../Makefile.inc

=== src/test/blk_non_zero/Makefile ===
# SPDX-License-Identifier: BSD-3-Clause
# Copyright 2015-2019, Intel Corporation

#
# src/test/blk_non_zero/Makefile -- build blk_non_zero unit test
#
TARGET = blk_non_zero
OBJS = blk_non_zero.o

LIBPMEMBLK=y

include ../Makefile.inc

INCS += -I../../libpmemblk

=== src/test/blk_rw_mt/Makefile ===
# SPDX-License-Identifier: BSD-3-Clause
# Copyright 2014-2019, Intel Corporation

#
# src/test/blk_rw_mt/Makefile -- build blk_rw_mt unit test
#
TARGET = blk_rw_mt
OBJS = blk_rw_mt.o

LIBPMEMBLK=y

include ../Makefile.inc

=== src/test/ex_libpmem/Makefile ===
# SPDX-License-Identifier: BSD-3-Clause
# Copyright 2015-2016, Intel Corporation

#
# src/test/ex_libpmem/Makefile -- build ex_libpmem unittest
#

all: $(EXAMPLES)
	$(MAKE) -C $(EX_LIBPMEM)

include ../Makefile.inc

EXAMPLES=$(EX_LIBPMEM)/simple_copy \
	$(EX_LIBPMEM)/full_copy

=== src/test/ex_libpmem2/Makefile ===
# SPDX-License-Identifier: BSD-3-Clause
# Copyright 2019-2021, Intel Corporation

#
# src/test/ex_libpmem2/Makefile -- build ex_libpmem2 unittest
#

all: $(EXAMPLES)
	$(MAKE) -C $(EX_LIBPMEM2)

include ../Makefile.inc

EXAMPLES=$(EX_LIBPMEM2)/basic\
	$(EX_LIBPMEM2)/advanced\
	$(EX_LIBPMEM2)/log\
	$(EX_LIBPMEM2)/ringbuf

=== src/test/ex_librpmem_basic/Makefile ===
# SPDX-License-Identifier: BSD-3-Clause
# Copyright 2019, Intel Corporation

#
# src/test/ex_librpmem_basic/Makefile -- prepare basic librpmem example
# unittest
#

include ../../common.inc

ifeq ($(BUILD_RPMEM), y)
SCP_TO_REMOTE_NODES = y
SCP_TARGET = basic
SCP_SRC_DIR = ../../examples/librpmem
endif

include ../Makefile.inc

=== src/test/libpmempool_feature/Makefile ===
# SPDX-License-Identifier: BSD-3-Clause
# Copyright 2018-2019, Intel Corporation

#
# src/test/libpmempool_feature/Makefile -- build libpmempool_feature unittest
#

TARGET = libpmempool_feature
OBJS = libpmempool_feature.o

LIBPMEMPOOL=y
LIBPMEMCOMMON=y

include ../Makefile.inc

=== src/test/log_include/Makefile ===
# SPDX-License-Identifier: BSD-3-Clause
# Copyright 2016-2019, Intel Corporation

#
# src/test/log_include/Makefile -- compilation test for libpmemlog
#
TARGET = log_include
OBJS = log_include.o

LIBPMEMLOG=y

include ../Makefile.inc

=== debian/changelog ===
pmdk (1.11.1-3build1) jammy; urgency=high

  * No change rebuild for ppc64el baseline bump.

 -- Julian Andres Klode <juliank@ubuntu.com>  Thu, 24 Mar 2022 17:22:51 +0100

pmdk (1.11.1-3) unstable; urgency=medium

  * Add lintian overrides for quirks of -debug packages.
  * Rework the way man pages are patched.
  * Cherry-pick riscv64 support.

 -- Adam Borowski <kilobyte@angband.pl>  Thu, 21 Oct 2021 18:27:53 +0200

pmdk (1.11.1-2) unstable; urgency=medium

  * Add helgrind suppressions for glibc-2.32/ppc64el.

 -- Adam Borowski <kilobyte@angband.pl>  Tue, 28 Sep 2021 12:57:41 +0200

pmdk (1.11.1-1) unstable; urgency=high

  * New upstream bugfix release, fixes a possible data loss on crash bug.
  * Add lplewa's upstream gpg key.

 -- Adam Borowski <kilobyte@angband.pl>  Mon, 27 Sep 2021 17:12:08 +0200

pmdk (1.11.0-2) unstable; urgency=medium

  * Upload to unstable.

 -- Adam Borowski <kilobyte@angband.pl>  Tue, 10 Aug 2021 14:27:49 +0200

pmdk (1.11.0-1) experimental; urgency=medium

  * New upstream release.
    + Fixes insufficient flushing on ARMv8.2+ (closes: #990573).

 -- Adam Borowski <kilobyte@angband.pl>  Fri, 02 Jul 2021 15:23:11 +0200

pmdk (1.11.0~rc2-1) experimental; urgency=medium

  * New upstream RC.
    + Fixes FTBFS issues with gcc-11 (closes: #984295).

 -- Adam Borowski <kilobyte@angband.pl>  Fri, 25 Jun 2021 14:49:07 +0200

pmdk (1.11.0~rc1-1) experimental; urgency=medium

  * New upstream RC.
  * New symbols.

 -- Adam Borowski <kilobyte@angband.pl>  Mon, 07 Jun 2021 19:32:39 +0200

=== debian/control ===
Source: pmdk
Section: libs
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Adam Borowski <kilobyte@angband.pl>
Build-Depends: bash-completion,
               bc,
               ed,
               debhelper-compat (= 12),
               dh-exec,
               libdaxctl-dev (>= 64),
               libfabric-dev,
               libndctl-dev (>= 64),
               pandoc,
               pkg-config,
               python3,
               strace,
               valgrind [!riscv64],
               valgrind (>= 1:3.15.0) [arm64],
Standards-Version: 4.6.0
Rules-Requires-Root: no
Homepage: https://pmem.io/pmdk/
Vcs-Git: https://github.com/kilobyte/pmdk -b debian
Vcs-Browser: https://github.com/kilobyte/pmdk/tree/debian

Package: libpmem1
Architecture: amd64 arm64 ppc64el riscv64
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Persistent Memory low level support library, v1 runtime
 libpmem provides low level persistent memory support.  In particular, support
 for the persistent memory instructions for flushing changes to pmem is
 provided.
 .
 This library is provided for software which tracks every store to pmem and
 needs to flush those changes to durability.  Most developers will find higher
 level libraries like libpmemobj to be much more convenient.
 .
 This package provides binary runtime for version 1 of the API.

Package: libpmem1-debug
Architecture: amd64 arm64 ppc64el riscv64
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Persistent Memory low level support library — debug build
 libpmem provides low level persistent memory support.  In particular, support
 for the persistent memory instructions for flushing changes to pmem is
 provided.
 .
 This package contains a special build of this library meant for debugging
 purposes.  It contains extra logging, assertions and expensive checks that
 should not be used otherwise.

Package: libpmem-dev
Section: libdevel
Architecture: amd64 arm64 ppc64el riscv64
Multi-Arch: same
Depends: libpmem1 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Description: Persistent Memory low level support library, v1 headers
 libpmem provides low level persistent memory support.  In particular, support
 for the persistent memory instructions for flushing changes to pmem is
 provided.
 .
 This package contains libraries and header files used for linking programs
 against libpmem.

Package: libpmem2
Architecture: amd64 arm64 ppc64el riscv64
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Persistent Memory low level support library, v2 runtime
 libpmem provides low level persistent memory support.  In particular, support
 for the persistent memory instructions for flushing changes to pmem is
 provided.
 .
 This library is provided for software which tracks every store to pmem and
 needs to flush those changes to durability.  Most developers will find higher
 level libraries like libpmemobj to be much more convenient.

Package: libpmem2-debug
Architecture: amd64 arm64 ppc64el riscv64
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Persistent Memory low level support library — debug build
 libpmem provides low level persistent memory support.  In particular, support
 for the persistent memory instructions for flushing changes to pmem is
 provided.
 .
 This package contains a special build of this library meant for debugging
 purposes.  It contains extra logging, assertions and expensive checks that
 should not be used otherwise.

Package: libpmem2-dev
Section: libdevel
Architecture: amd64 arm64 ppc64el riscv64
Multi-Arch: same
Depends: libpmem2 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Description: Persistent Memory low level support library, v2 headers
 libpmem provides low level persistent memory support.  In particular, support
 for the persistent memory instructions for flushing changes to pmem is
 provided.
 .
 This package contains libraries and header files used for linking programs
 against libpmem2, with a modernized API that avoids certain limitations of
 libpmem1.

Package: libpmemblk1
Architecture: amd64 arm64 ppc64el riscv64
Multi-Arch: same
Depends: libpmem1 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Description: Persistent Memory block array support library
 libpmemblk implements a pmem-resident array of blocks, all the same size, where
 a block is updated atomically with respect to power failure or program
 interruption (no torn blocks).
 .
 This library is provided for cases requiring large arrays of objects at least
 512 bytes each.  Most developers will find higher level libraries like
 libpmemobj to be more generally useful.

Package: libpmemblk1-debug
Architecture: amd64 arm64 ppc64el riscv64
Multi-Arch: same
Depends: libpmem1-debug (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: Persistent Memory block array support library — debug build
 libpmemblk implements a pmem-resident array of blocks, all the same size, where
 a block is updated atomically with respect to power failure or program
 interruption (no torn blocks).
 .
 This library is provided for cases requiring large arrays of objects at least
 512 bytes each.  Most developers will find higher level libraries like
 libpmemobj to be more generally useful.
 .
 This package contains a special build of this library meant for debugging
 purposes.  It contains extra logging, assertions and expensive checks that
 should not be used otherwise.

Package: libpmemblk-dev
Section: libdevel
Architecture: amd64 arm64 ppc64el riscv64
Multi-Arch: same
Depends: libpmem-dev (= ${binary:Version}),
         libpmemblk1 (= ${binary:Version}),
         libndctl-dev (>= 63),
         libdaxctl-dev (>= 63),
         ${misc:Depends},
         ${shlibs:Depends}
Description: development files for libpmemblk1
 libpmemblk implements a pmem-resident array of blocks, all the same size, where
 a block is updated atomically with respect to power failure or program
 interruption (no torn blocks).
 .
 This package contains libraries and header files used for linking programs
 against libpmemblk.

Package: libpmemlog1
Architecture: amd64 arm64 ppc64el riscv64
Multi-Arch: same
Depends: libpmem1 (=${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Description: Persistent Memory log file support library
 libpmemlog implements a pmem-resident log file.
 .
 This library is provided for cases requiring an append-mostly file to record
 variable length entries.  Most developers will find higher level libraries like
 libpmemobj to be more generally useful.

Package: libpmemlog1-debug
Architecture: amd64 arm64 ppc64el riscv64
Multi-Arch: same
Depends: libpmem1-debug (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: Persistent Memory log file support library — debug build
 libpmemlog implements a pmem-resident log file.
 .
 This library is provided for cases requiring an append-mostly file to record
 variable length entries.  Most developers will find higher level libraries like
 libpmemobj to be more generally useful.
 .
 This package contains a special build of this library meant for debugging
 purposes.  It contains extra logging, assertions and expensive checks that
 should not be used otherwise.

Package: libpmemlog-dev
Section: libdevel
Architecture: amd64 arm64 ppc64el riscv64
Multi-Arch: same
Depends: libpmem-dev (= ${binary:Version}),
         libpmemlog1 (= ${binary:Version}),
         libndctl-dev (>= 63),
         libdaxctl-dev (>= 63),
         ${misc:Depends},
         ${shlibs:Depends}
Description: development files for libpmemlog1
 libpmemlog implements a pmem-resident log file.
 .
 This package contains libraries and header files used for linking programs
 against libpmemlog.

Package: libpmemobj1
Architecture: amd64 arm64 ppc64el riscv64
Multi-Arch: same
Depends: libpmem1 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Description: Persistent Memory object store support library
 libpmemobj turns a persistent memory file into a flexible object store,
 supporting transactions, memory management, locking, lists, and a number of
 other features.

Package: libpmemobj1-debug
Architecture: amd64 arm64 ppc64el riscv64
Multi-Arch: same
Depends: libpmem1-debug (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: Persistent Memory object store support library — debug build
 libpmemobj turns a persistent memory file into a flexible object store,
 supporting transactions, memory management, locking, lists, and a number of
 other features.
 .
 This package contains a special build of this library meant for debugging
 purposes.  It contains extra logging, assertions and expensive checks that
 should not be used otherwise.

Package: libpmemobj-dev
Section: libdevel
Architecture: amd64 arm64 ppc64el riscv64
Multi-Arch: same
Depends: libpmem-dev (= ${binary:Version}),
         libpmemobj1 (= ${binary:Version}),
         libndctl-dev (>= 63),
         libdaxctl-dev (>= 63),
         ${misc:Depends},
         ${shlibs:Depends}
Description: development files for libpmemobj1
 libpmemobj turns a persistent memory file into a flexible object store,
 supporting transactions, memory management, locking, lists, and a number of
 other features.
 .
 This package contains libraries and header files used for linking programs
 against libpmemobj.

Package: libpmempool1
Architecture: amd64 arm64 ppc64el riscv64
Multi-Arch: same
Depends: libpmem1 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Description: Persistent Memory pool management support library
 libpmempool provides a set of utilities for management, diagnostics and repair
 of persistent memory pools.  A pool in this context means a pmemobj pool,
 pmemblk pool, pmemlog pool or BTT layout, independent of the underlying
 storage.  The libpmempool is for applications that need high reliability or
 built-in troubleshooting.  It may be useful for testing and debugging purposes
 also.

Package: libpmempool1-debug
Architecture: amd64 arm64 ppc64el riscv64
Multi-Arch: same
Depends: libpmem1-debug (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: Persistent Memory pool management support library — debug build
 libpmempool provides a set of utilities for management, diagnostics and repair
 of persistent memory pools.  A pool in this context means a pmemobj pool,
 pmemblk pool, pmemlog pool or BTT layout, independent of the underlying
 storage.  The libpmempool is for applications that need high reliability or
 built-in troubleshooting.  It may be useful for testing and debugging purposes
 also.
 .
 This package contains a special build of this library meant for debugging
 purposes.  It contains extra logging, assertions and expensive checks that
 should not be used otherwise.

Package: libpmempool-dev
Section: libdevel
Architecture: amd64 arm64 ppc64el riscv64
Multi-Arch: same
Depends: libpmem-dev (= ${binary:Version}),
         libpmempool1 (= ${binary:Version}),
         libndctl-dev (>= 63),
         libdaxctl-dev (>= 63),
         ${misc:Depends},
         ${shlibs:Depends}
Description: development files for libpmempool1
 libpmempool provides a set of utilities for management, diagnostics and repair
 of persistent memory pools.
 .
 This package contains libraries and header files used for linking programs
 against libpmempool.

Package: librpmem1
Architecture: amd64 arm64 ppc64el riscv64
Multi-Arch: same
Depends: libpmem1 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Description: Persistent Memory remote access support library
 librpmem provides low-level support for remote access to persistent memory
 (pmem) utilizing RDMA-capable RNICs.  The library can be used to replicate
 remotely a memory region over RDMA protocol.  It utilizes appropriate

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
DEB_UPSTREAM_VERSION = $(shell dpkg-parsechangelog -S version | cut -d - -f 1 | cut -d : -f 2)

BUILD_ARGS = prefix=/usr libdir=/usr/lib/$(DEB_HOST_MULTIARCH) sysconfdir=/etc bashcompdir=/usr/share/bash-completion/completions NORPATH=1 BUILD_EXAMPLES=n BUILD_BENCHMARKS=n

%:
	dh $@ --with bash-completion

override_dh_auto_clean:
	dh_auto_clean
	rm -rf src/test/unittest/__pycache__/

override_dh_auto_build:
	+$(MAKE) doc
	for x in `grep -l _LOG_LEVEL doc/lib*/lib*.7`; do \
		ed -s <debian/man-debug.ed $$x; done
	dh_auto_build  -- $(BUILD_ARGS)

override_dh_auto_install:
	dh_auto_install -- $(BUILD_ARGS)

override_dh_install:
	mkdir -p debian/tmp/usr/share/pmdk/
	cp utils/pmdk.magic debian/tmp/usr/share/pmdk/
	dh_install

override_dh_installexamples:
	dh_installexamples --exclude=.gitignore --exclude=.vcxproj

override_dh_installman:
	dh_installman
	dh_installman -p pmdk-tools doc/rpmemd/*.1

override_dh_missing:
	dh_missing --list-missing --exclude=usr/share/man --exclude=usr/lib/$(DEB_HOST_MULTIARCH)/pmdk_debug/ --exclude=usr/share/bash-completion/completions/pmempool

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	cp debian/testconfig.* src/test/
	# Still fails/times out on weird setups (a 33GB fallocate).
	rm -f src/test/obj_pool/TEST34
	# binutils regression #964457
	rm -rf src/test/scope/TESTS.py
	+$(MAKE) check pycheck $(BUILD_ARGS)
endif

## pmdk 1.12.0

=== src/common/Makefile ===
# SPDX-License-Identifier: BSD-3-Clause
# Copyright 2014-2022, Intel Corporation

#
# src/common/Makefile -- Makefile for common
#

LIBRARY_NAME = pmemcommon

include pmemcommon.inc

include ../Makefile.inc

CFLAGS += $(LIBNDCTL_CFLAGS) $(MINIASYNC_CFLAGS) -DPMEM2_USE_MINIASYNC=1
CFLAGS += -DUSE_LIBDL
# Librpmem is deprecated.
# This flag allows to build tests, examples and benchmarks
# using rpmem despite the deprecated state.
CFLAGS += -Wno-deprecated-declarations

=== src/core/Makefile ===
# SPDX-License-Identifier: BSD-3-Clause
# Copyright 2020-2022, Intel Corporation

#
# src/core/Makefile -- Makefile for core
#

LIBRARY_NAME = pmemcore

include pmemcore.inc

include ../Makefile.inc

# Librpmem is deprecated.
# This flag allows to build tests, examples and benchmarks
# using rpmem despite the deprecated state.
CFLAGS += -Wno-deprecated-declarations

=== src/test/Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 # SPDX-License-Identifier: BSD-3-Clause
-# Copyright 2014-2021, Intel Corporation
+# Copyright 2014-2022, Intel Corporation
 #
 
 #
@@ -193,12 +193,14 @@
 	pmem_memset\
 	pmem_movnt\
 	pmem_movnt_align\
+	pmem_eADR_functions\
 	pmem_valgr_simple\
 	pmem_unmap
 
 PMEM2_TESTS = \
 	pmem2_api\
 	pmem2_compat\
+	pmem2_badblock\
 	pmem2_config\
 	pmem2_source\
 	pmem2_source_alignment\
@@ -220,7 +222,8 @@
 	pmem2_movnt_align\
 	pmem2_mem_ext\
 	pmem2_deep_flush\
-	pmem2_vm_reservation
+	pmem2_vm_reservation\
+	pmem2_usc
 
 ifeq ($(OS_DIMM),ndctl)
 PMEM2_TESTS += \
@@ -229,6 +232,14 @@
 else
 $(info NOTE: Skipping tests because libndctl is disabled (see NDCTL_ENABLE)\
 		Skipped tests: pmem2_badblock_mocks pmem2_source_numa)
+endif
+
+ifeq ($(OS_KERNEL_NAME),Linux)
+PMEM2_TESTS += pmem2_mover
+PMEM2_TESTS += pmem2_future
+else
+$(info NOTE: Skipping tests because miniasync is not supported on this os.\
+		Skipped tests: pmem2_mover, pmem2_future)
 endif
 
 PMEMPOOL_TESTS = \
@@ -263,7 +274,9 @@
 	ex_libpmemblk\
 	ex_libpmemlog\
 	ex_libpmemobj\
-	ex_linkedlist
+	ex_libpmemset\
+	ex_linkedlist\
+	ex_pmreorder
 
 RPMEM_EXAMPLES_TESTS = \
 	ex_librpmem_manpage\
@@ -298,11 +311,13 @@
 	pmreorder_stack
 
 PMEMSET_TESTS = \
+	pmemset_badblock\
 	pmemset_config\
 	pmemset_deep_flush\
 	pmemset_event\
 	pmemset_file\
 	pmemset_include\
+	pmemset_map_config\
 	pmemset_memcpy\
 	pmemset_memmove\
 	pmemset_memset\
@@ -310,6 +325,7 @@
 	pmemset_part\
 	pmemset_perror\
 	pmemset_persist\
+	pmemset_sds\
 	pmemset_source
 
 LOCAL_TESTS = \
@@ -408,9 +424,12 @@
 PMEM2_AVX512F_ENABLED := $(shell strings $(TOP)/src/debug/libpmem2/libpmem2_all.o 2>&1 | \
 	grep -q "avx512f supported, but disabled at build time" && echo "0" || echo "1")
 
+PMEM2_MOVDIR64B_ENABLED := $(shell strings $(TOP)/src/debug/libpmem2/libpmem2_all.o 2>&1 | \
+	grep -q "movdir64b supported, but disabled at build time" && echo "0" || echo "1")
+
 envconfig.py:
-	@printf "# autogenerated file\nconfig = {\n  'GLOBAL_LIB_PATH': '%s',\n  'PMEM2_AVX512F_ENABLED': '%s',\n  'GLOBAL_PATH': '%s',\n  'GLOBAL_PKG_CONFIG_PATH': '%s'\n}\n" \
-		"$(LIBFABRIC_LD_LIBRARY_PATHS):$(LIBNDCTL_LD_LIBRARY_PATHS)" "$(PMEM2_AVX512F_ENABLED)" "$(LIBFABRIC_PATH)" "$(PKG_CONFIG_PATH)" > envconfig.py
+	@printf "# autogenerated file\nconfig = {\n  'GLOBAL_LIB_PATH': '%s',\n  'PMEM2_AVX512F_ENABLED': '%s',\n  'PMEM2_MOVDIR64B_ENABLED': '%s',\n  'GLOBAL_PATH': '%s',\n  'GLOBAL_PKG_CONFIG_PATH': '%s'\n}\n" \
+		"$(LIBFABRIC_LD_LIBRARY_PATHS):$(LIBNDCTL_LD_LIBRARY_PATHS)" "$(PMEM2_AVX512F_ENABLED)" "$(PMEM2_MOVDIR64B_ENABLED)" "$(LIBFABRIC_PATH)" "$(PKG_CONFIG_PATH)" > envconfig.py
 
 require-rpmem:
 ifneq ($(BUILD_RPMEM),y)

=== src/deps/miniasync/examples/CMakeLists.txt ===
#
# SPDX-License-Identifier: BSD-3-Clause
# Copyright 2021-2022, Intel Corporation
#

add_custom_target(examples)

# add compiler flags using macro defined in functions.cmake file
add_flag(-Wall)
add_flag(-Wpointer-arith)
add_flag(-Wsign-compare)
add_flag(-Wunreachable-code-return)
add_flag(-Wmissing-variable-declarations)
add_flag(-fno-common)
add_flag(-Wunused-macros)
add_flag(-Wsign-conversion)

add_flag(-ggdb DEBUG)
add_flag(-DDEBUG DEBUG)

add_flag("-U_FORTIFY_SOURCE -D_FORTIFY_SOURCE=2" RELEASE)

add_cstyle(examples-all ${CMAKE_CURRENT_SOURCE_DIR}/*/*.[ch])
add_check_whitespace(examples-all
		${CMAKE_CURRENT_SOURCE_DIR}/*/*.[ch]
		${CMAKE_CURRENT_SOURCE_DIR}/CMakeLists.txt
		${CMAKE_CURRENT_SOURCE_DIR}/README.md)

# add_example-- function for adding an example.
#		After the required name parameter, next parameters
#		passed to this function are example's sources.
function(add_example name)
	include_directories(
		${MINIASYNC_SOURCE_DIR}
		${MINIASYNC_INCLUDE_DIR})
	set(srcs ${ARGN})
	prepend(srcs ${CMAKE_CURRENT_SOURCE_DIR} ${srcs})
	add_executable(example-${name} ${srcs})
	target_link_libraries(example-${name} miniasync ${CMAKE_THREAD_LIBS_INIT})
	add_dependencies(examples example-${name})
endfunction()

# add all the examples with a use of the add_example function defined above
add_example(basic basic/basic.c)
add_example(basic-async basic-async/basic-async.c)

=== src/deps/miniasync/tests/CMakeLists.txt ===
#
# SPDX-License-Identifier: BSD-3-Clause
# Copyright 2021-2022, Intel Corporation
#

include(cmake/ctest_helpers.cmake)

set(LIBS_BASIC
	miniasync
	cores
	${CMAKE_THREAD_LIBS_INIT})

set(LIBS_DML
	miniasync-vdm-dml
	${LIBS_BASIC})

set(SOURCES_UTIL_DML
	${CORE_SOURCE_DIR}/cpu.c
	${MINIASYNC_DML_SOURCE_DIR}/utils/util_dml.c)

set(SOURCES_DUMMY_TEST
	dummy/dummy.c)

set(SOURCES_DUMMY_NEGATIVE_TEST
	dummy_negative/dummy_negative.c)

set(SOURCES_FUTURE_TEST
	future/test_future.c)

set(SOURCES_MEMCPY_PTHREADS_TEST
	memcpy_threads/memcpy_threads.c)

set(SOURCES_DATA_MOVER_DML_TEST_MEMCPY
	data_mover_dml_memcpy/data_mover_dml_memcpy.c
	${SOURCES_UTIL_DML})

set(SOURCES_DATA_MOVER_DML_TEST_MEMMOVE
	data_mover_dml_memmove/data_mover_dml_memmove.c
	${SOURCES_UTIL_DML})

set(SOURCES_DATA_MOVER_DML_TEST_MEMSET
	data_mover_dml_memset/data_mover_dml_memset.c
	${SOURCES_UTIL_DML})

set(SOURCES_MEMBUF_TEST
	membuf/membuf_simple.c)

set(SOURCES_MEMMOVE_SYNC_TEST
	memmove_sync/memmove_sync.c)

set(SOURCES_VDM_TEST
	vdm/test_vdm.c)

set(SOURCES_MEMSET_SYNC_TEST
	memset_sync/memset_sync.c)

set(SOURCES_VDM_OPERATION_FUTURE_POLL
	vdm_operation_future_poll/vdm_operation_future_poll.c
	${SOURCES_UTIL_DML})

set(SOURCES_MEMMOVE_THREADS_TEST
	memmove_threads/memmove_threads.c)

set(SOURCES_MEMSET_THREADS_TEST
	memset_threads/memset_threads.c)

add_custom_target(tests)

add_flag(-Wall)

add_cstyle(tests-all
		${CMAKE_CURRENT_SOURCE_DIR}/*/*.[ch]
		${CMAKE_CURRENT_SOURCE_DIR}/*.[ch])
add_check_whitespace(tests-all
		${CMAKE_CURRENT_SOURCE_DIR}/*/*.[ch]
		${CMAKE_CURRENT_SOURCE_DIR}/*.[ch]
		${CMAKE_CURRENT_SOURCE_DIR}/CMakeLists.txt
		"${CMAKE_CURRENT_SOURCE_DIR}/*/*[.cmake]"
		"${CMAKE_CURRENT_SOURCE_DIR}/cmake/*[.cmake]")

include_directories(
		${MINIASYNC_SOURCE_DIR}
		${MINIASYNC_INCLUDE_DIR}
		${CMAKE_CURRENT_SOURCE_DIR})

# add and link all the executables for tests
add_link_executable(dummy
		"${SOURCES_DUMMY_TEST}"
		"${LIBS_BASIC}")

add_link_executable(dummy_negative
		"${SOURCES_DUMMY_NEGATIVE_TEST}"
		"${LIBS_BASIC}")

add_link_executable(future
		"${SOURCES_FUTURE_TEST}"
		"${LIBS_BASIC}")

add_link_executable(memcpy_threads
		"${SOURCES_MEMCPY_PTHREADS_TEST}"
		"${LIBS_BASIC}")

add_link_executable(membuf
		"${SOURCES_MEMBUF_TEST}"
		"${LIBS_BASIC}")

add_link_executable(memmove_sync
		"${SOURCES_MEMMOVE_SYNC_TEST}"
		"${LIBS_BASIC}")

add_link_executable(vdm
		"${SOURCES_VDM_TEST}"
		"${LIBS_BASIC}")

add_link_executable(memset_sync
		"${SOURCES_MEMSET_SYNC_TEST}"
		"${LIBS_BASIC}")

add_link_executable(memmove_threads
		"${SOURCES_MEMMOVE_THREADS_TEST}"
		"${LIBS_BASIC}")

add_link_executable(memset_threads
		"${SOURCES_MEMSET_THREADS_TEST}"
		"${LIBS_BASIC}")

# add test using test function defined in the ctest_helpers.cmake file
test("dummy" "dummy" test_dummy none)
test("dummy_drd" "dummy" test_dummy drd)
test("dummy_helgrind" "dummy" test_dummy helgrind)
test("dummy_memcheck" "dummy" test_dummy memcheck)
test("dummy_negative" "dummy_negative" test_dummy_negative none)
test("future" "future" test_future none)
test("future_memcheck" "future" test_future memcheck)
test("memcpy_threads" "memcpy_threads" test_memcpy_threads none)
test("membuf" "membuf" test_membuf none)
test("memmove_sync" "memmove_sync" test_memmove_sync none)
test("vdm" "vdm" test_vdm none)
test("memset_sync" "memset_sync" test_memset_sync none)
test("memmove_threads" "memmove_threads" test_memmove_threads none)
test("memset_threads" "memset_threads" test_memset_threads none)

# add tests running examples only if they are built
if(BUILD_EXAMPLES)
	test("ex_basic" "ex_basic" test_ex_basic none)
	test("ex_basic_async" "ex_basic_async" test_ex_basic_async none)
endif()

# add miniasync-vdm-dml test only if the sources in extras/dml were compiled
if (COMPILE_DML)
	add_link_executable(data_mover_dml_memcpy
			"${SOURCES_DATA_MOVER_DML_TEST_MEMCPY}"
			"${LIBS_DML}")

	add_link_executable(data_mover_dml_memmove
			"${SOURCES_DATA_MOVER_DML_TEST_MEMMOVE}"
			"${LIBS_DML}")

	add_link_executable(data_mover_dml_memset
			"${SOURCES_DATA_MOVER_DML_TEST_MEMSET}"
			"${LIBS_DML}")

	add_link_executable(vdm_operation_future_poll
			"${SOURCES_VDM_OPERATION_FUTURE_POLL}"
			"${LIBS_DML}")

	test("data_mover_dml_memcpy" "data_mover_dml_memcpy" test_data_mover_dml_memcpy none)
	test("data_mover_dml_memmove" "data_mover_dml_memmove" test_data_mover_dml_memmove none)
	test("data_mover_dml_memset" "data_mover_dml_memset" test_data_mover_dml_memset none)
	test("vdm_operation_future_poll" "vdm_operation_future_poll" test_vdm_operation_future_poll none)
endif()

=== debian/changelog ===
pmdk (1.12.0-2) unstable; urgency=medium

  [ Sergio Durigan Junior ]
  * d/rules: Temporarily disable obj_ctl_arenas/TEST3
    and pmem2_future/TESTS.py. (Closes: #1012519)

 -- Adam Borowski <kilobyte@angband.pl>  Sat, 25 Jun 2022 14:04:51 +0200

pmdk (1.12.0-1) unstable; urgency=medium

  * New upstream release.

 -- Adam Borowski <kilobyte@angband.pl>  Tue, 24 May 2022 21:57:42 +0200

pmdk (1.12.0~rc1-1) experimental; urgency=medium

  * New upstream RC.
  * Add Weronika's gpg key.
  * B-Depend on cmake, ndctl.
  * New symbols.

 -- Adam Borowski <kilobyte@angband.pl>  Thu, 19 May 2022 14:27:15 +0200

pmdk (1.11.1-4) unstable; urgency=medium

  * B-Depend on valgrind-if-available.
  * Fix build failure with ndctl 73.

 -- Adam Borowski <kilobyte@angband.pl>  Mon, 16 May 2022 16:18:41 +0200

=== debian/control ===
--- 
+++ 
@@ -1,21 +1,22 @@
 Source: pmdk
 Section: libs
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Adam Borowski <kilobyte@angband.pl>
+Maintainer: Adam Borowski <kilobyte@angband.pl>
 Build-Depends: bash-completion,
                bc,
+               cmake,
                ed,
                debhelper-compat (= 12),
                dh-exec,
                libdaxctl-dev (>= 64),
                libfabric-dev,
                libndctl-dev (>= 64),
+               ndctl,
                pandoc,
                pkg-config,
                python3,
                strace,
-               valgrind [!riscv64],
+               valgrind-if-available,
                valgrind (>= 1:3.15.0) [arm64],
 Standards-Version: 4.6.0
 Rules-Requires-Root: no
@@ -295,3 +296,4 @@
  librpmem provides low-level support for remote access to persistent memory
  (pmem) utilizing RDMA-capable RNICs.  The library can be used to replicate
  remotely a memory region over RDMA protocol.  It utilizes appropriate
+ persistency mechanism based on remote node’s platform capabilities.  The
